#!/usr/bin/env python
# -*- coding:utf-8 -*-
#制作:温赫男

'''帐号列表
'''
from sale_amazon.models import *
from sale_amazon import misc
#from market.models import Store


class Store(models.Model):

    #objects = EntityManager('order.store_management',permission_all = 'order.store_management_all',property_entity_list = [('', 'order.Store')])
    idstore = models.AutoField(primary_key=True)
    #market = models.ForeignKey('Market',db_constraint=False,null=True,related_name='store_market')
    market_id = models.IntegerField(default=0)
    # 显示分组的时候用来作为分组处理的
    desc = models.CharField(max_length=100L, blank=True, null=True)
    user_iduser = models.IntegerField(db_column='user_iduser_id', blank=True, null=True)
    name = models.CharField(max_length=100L, blank=True, null=True)
    channel = models.CharField(max_length=100L, blank=True, null=True)
    is_online = models.BooleanField(default=True)
    account_id = models.IntegerField(default=0)
    platform_store_name = models.CharField(max_length=100L, blank=True, null=True)
    # 产品的默认仓库

    class Meta:
        db_table = 'store'
        managed = False

    def __str__(self):
        return str(self.name)

    @classmethod
    def get_stores(cls):
        stores = cls.objects.filter().values('name','idstore')
        return stores
    @classmethod
    def get_stores_by_channel(cls,channel):
        stores = cls.objects.filter(channel=channel).values('name','idstore')
        return stores


'''
class Amazon_Account(models.Model):
    idamazon_account = models.AutoField(primary_key=True)
    name = models.CharField(max_length=100L, blank=True, null=True)
    ACCESS_KEY = models.CharField(max_length=200L, blank=True, null=True)
    SECRET_KEY = models.CharField(max_length=200L, blank=True, null=True)
    ACCOUNT_ID = models.CharField(max_length=200L, blank=True, null=True)
    MKPLACEID = models.CharField(max_length=200L, blank=True, null=True)
    MWSAuthToken = models.CharField(max_length=2000L, blank=True, null=True)

    class Meta:
        db_table = 'amazon_account'
        app_label = 'sale_amazon'

    def __str__(self):
        return str(self.name)
'''


class Amazon_Account(object):
    def __init__(self, idamazon_account, name, ACCESS_KEY, SECRET_KEY, ACCOUNT_ID, MKPLACEID, MWSAuthToken):
        self.idamazon_account = idamazon_account
        self.name = name
        self.ACCESS_KEY = ACCESS_KEY
        self.SECRET_KEY = SECRET_KEY
        self.ACCOUNT_ID = ACCOUNT_ID
        self.MKPLACEID = MKPLACEID
        self.MWSAuthToken = MWSAuthToken


class _CTime(object):
    c_LastTime = 0
    @classmethod
    def Clear(cls):
        import time
        cls.c_LastTime = time.time()

    @classmethod
    def PrintSpace(cls,msg):
        import time
        now = time.time()
        print msg,"---",now-cls.c_LastTime
        #cls.c_LastTime = time.time()

def GetUserID(user_name):
    from django.contrib.auth import get_user_model
    User = get_user_model()
    info = User.objects.filter(username=user_name).values("id").first()
    if info:
        return info["id"]
    else:
        return 0

def _get_xls_data(filename):
    import xlrd

    #fname = "amazon 深圳ASIN与销售对应关系.xls"
    bk = xlrd.open_workbook(filename)
    shxrange = range(bk.nsheets)
    try:
        sh = bk.sheet_by_name("Sheet1")
    except:
        return [],"文件找不到<Sheet1>分页"
    # 获取行数
    nrows = sh.nrows
    # 获取列数
    ncols = sh.ncols
    print "nrows %d, ncols %d" % (nrows, ncols)
    # 获取第一行第一列数据
    cell_value = sh.cell_value(1, 1)
    row_list = []
    # 获取各行数据
    for i in range(1, nrows):
        row_data = sh.row_values(i)
        row_list.append(row_data)
    return row_list,""



class CAmzStore_Info(object):
    @classmethod
    def Get_List_Json(cls,**params):
        limit = misc.GetInt(params, "limit", 20)
        offset = misc.GetInt(params, "offset", 0)

        oQuery = AmazonAccount.objects.filter()
        store_list = oQuery.all().values()

        alldata = []
        for store_info in store_list[offset:offset + limit]:
            alldata.append(store_info)
        total = oQuery.count()
        return alldata,total


    @classmethod
    def GetStoreInfo(cls,store_id,*args):
        return AmazonAccount.objects.filter(idamazon_account=store_id).values(*args).first()

    @classmethod
    def ExistStore(cls,store_id):
        return AmazonAccount.objects.filter(idamazon_account=store_id).exists()

    @classmethod
    def GetStore_ID(cls,store_name):
        info = AmazonAccount.objects.filter(name=store_name).values("idamazon_account").first()
        if info:
            return info["idamazon_account"]
        return 0



class CAmzCharger_Info(object):
    def __init__(self,data):
        data.extend([""] * 6)
        self.m_InputData = data
        self.m_GateWay_ID = 0
        self.m_Charger_ID = 0
        self.m_GateWay_Name = ""
        self.m_Charger_Name= ""
        self.m_Asin = ""
        self.m_SaleType = 0#1自建2跟卖0无效输入
        self.m_Result = ""
        self.m_Errmsg = ""

    @classmethod
    def Get_List_Json(cls,params):
        limit = misc.GetInt(params, "limit", 20)
        offset = misc.GetInt(params, "offset", 0)
        show_err = misc.GetInt(params, "show_err", 0)

        charger_name = misc.GetStr(params, "charger_name")
        asin = misc.GetStr(params, "asin")
        gateway_name = misc.GetStr(params, "gateway_name")


        oQuery = AmazonCharger.objects.filter()
        if show_err:
            oQuery = oQuery.exclude(errmsg="")
            #oQuery = oQuery.exclude(errmsg__isnull=1)

        if charger_name:
            oQuery = oQuery.filter(charger_name__icontains=charger_name)

        if asin:
            oQuery = oQuery.filter(asin__icontains=asin)

        if gateway_name:
            oQuery = oQuery.filter(gateway_name__icontains=gateway_name)
        oQuery = oQuery.order_by("-id")
        store_list = oQuery.all().values()



        alldata = []
        for store_info in store_list[offset:offset + limit]:
            alldata.append(store_info)
        total = store_list.count()
        return alldata,total

    @classmethod
    def EditCharger(cls,table_id,asin,charger_id,charger_name,gateway_id,gateway_name,saletype):
        obj = AmazonCharger.objects.filter(id=table_id).first()
        obj.charger_id = charger_id
        obj.charger_name = charger_name
        obj.asin = asin
        obj.gateway_id = gateway_id
        obj.gateway_name = gateway_name
        obj.saletype = saletype
        obj.errmsg = ""
        obj.save()

    @classmethod
    def AddCharger(cls,asin,charger_id,charger_name,gateway_id,gateway_name,saletype):
        obj = AmazonCharger()
        #info = AmazonCharger.objects.filter(asin=asin).filter(gateway_name=gateway_name).ex()

        obj.charger_id = charger_id
        obj.charger_name = charger_name
        obj.asin = asin
        obj.gateway_id = gateway_id
        obj.gateway_name = gateway_name
        obj.saletype = saletype
        obj.errmsg = ""
        obj.save()

    def SetSaleType(self,saletypetxt):
        if saletypetxt=="自建":
            self.m_SaleType = 1
        elif saletypetxt=="跟卖":
            self.m_SaleType = 2
        else:
            self.m_SaleType = 0
        if self.m_SaleType == 0:
            self.SetErrMsg("无效上架方式")

    def SetGateWay_Name(self,gateway_name):
        gateway_id = self.GetGateWay_ID(gateway_name)

        self.m_GateWay_Name = gateway_name
        self.m_GateWay_ID = gateway_id
        if gateway_id == 0:
            self.SetErrMsg("无效网关信息")

    @classmethod
    def GetGateWay_ID(cls,gateway_name):
        storeinfo = Store.objects.filter(name=gateway_name).values().first()
        if storeinfo:
            return storeinfo["idstore"]
        return 0

    def SetCharger_Name(self, charger_name):
        charger_id = GetUserID(charger_name)
        self.m_Charger_Name = charger_name
        self.m_Charger_ID = charger_id
        if charger_id==0:
            self.SetErrMsg("无效销售人")


    def SetErrMsg(self,msg):
        self.m_Errmsg = msg

    @classmethod
    def Bulk_Add(cls,filename):
        _CTime.Clear()
        _CTime.PrintSpace("开始处理文件")


        alldata,errmsg = _get_xls_data(filename)
        if errmsg:
            return errmsg

        inputdata = {}

        allchargers = []
        allct = len(alldata)
        ct = 0
        for olddata in alldata:
            charger = CAmzCharger_Info(olddata)

            ct += 1
            if ct %100==0:
                _CTime.PrintSpace("分析数据%s/%s"%(ct,allct))
            #print olddata
            line ="||".join([str(i) for i in olddata])
            line.replace(" ","")
            if line =="":#空行不处理
                continue
            data = line.split("||")

            asin = misc.GetStr(data,0)
            gateway_name = misc.GetStr(data, 1)
            charger_name = misc.GetStr(data, 2)
            saletypetxt = misc.GetStr(data, 3)

            charger.SetCharger_Name(charger_name)
            charger.SetGateWay_Name(gateway_name)

            charger.m_Asin = asin
            charger.SetSaleType(saletypetxt)

            if ( asin==""  or gateway_name=="" \
                         or charger_name == ""
                         or saletypetxt == "" ):
                charger.SetErrMsg("包含空列")
                continue
            if inputdata.get((asin, gateway_name),"")==1:
                #allchargers.pop()#已存在的不保存在新文件重
                charger.SetErrMsg("已存在，该更新被忽略")
                continue
            else:
                charger.DoSave()
            allchargers.append(charger)
            inputdata[(asin,gateway_name)]= 1



        return allchargers



    c_AllData = []
    c_NeedCheck = True
    @classmethod
    def ReadXls(cls,filename):
        _CTime.Clear()
        _CTime.PrintSpace("开始处理文件")
        AmazonCharger.objects.all().delete()
        _CTime.PrintSpace("清空数据")
        alldata,errmsg = _get_xls_data(filename)
        if errmsg:
            return errmsg

        inputdata = {}

        allchargers = []
        allct = len(alldata)
        ct = 0
        for olddata in alldata[1:]:
            charger = CAmzCharger_Info(olddata)
            allchargers.append(charger)
            ct += 1
            if ct %1000==0:
                _CTime.PrintSpace("分析数据%s/%s"%(ct,allct))
            #print olddata
            line ="||".join([str(i) for i in olddata])
            line.replace(" ","")
            if line =="":#空行不处理
                continue
            data = line.split("||")

            asin = misc.GetStr(data,0)
            gateway_name = misc.GetStr(data, 1)
            charger_name = misc.GetStr(data, 2)
            saletypetxt = misc.GetStr(data, 3)
            # try:
            #     asin,gateway_name,charger_name,saletypetxt =data[:4]
            # except:
            #     charger.SetErrMsg("不足4列")
            #     continue
            charger.m_Charger_Name = charger_name
            charger.m_GateWay_Name = gateway_name
            charger.m_Asin = asin
            charger.SetSaleType(saletypetxt)

            if ( asin==""  or gateway_name=="" \
                         or charger_name == ""
                         or saletypetxt == "" ):
                charger.SetErrMsg("包含空列")
                continue
            if inputdata.get((asin, gateway_name),"")==1:
                allchargers.pop()#已存在的不保存在新文件重
                charger.SetErrMsg("已存在，该更新被忽略")
                continue

            gateway_id = 0
            storeinfo = Store.objects.filter(name=gateway_name).values().first()
            if storeinfo:
                gateway_id = storeinfo["idstore"]

            #gateway_id = CAmzStore_Info.GetStore_ID(gateway_name)
            charger_id = GetUserID(charger_name)
            #if cls.c_NeedCheck:
            if gateway_id==0:
                charger.SetErrMsg("无效网关信息")
                continue
            charger.m_Charger_ID = charger_id
            if charger_id==0:
                charger.SetErrMsg("无效销售人")
                continue
            charger.m_GateWay_ID = gateway_id


            #if cls.c_NeedCheck:
            if charger.m_SaleType == 0:
                charger.SetErrMsg("无效上架方式")
                continue

            inputdata[(asin,gateway_name)]= 1

        #
        # ct = 0
        # for charger in allchargers:
        #     ct += 1
        #     if ct %1000==0:
        #         _CTime.PrintSpace("保存数据%s/%s"%(ct,allct))
        #     charger.DoSave()
        CAmzCharger_Info.BlukSave(allchargers)

        return allchargers

    @classmethod
    def CalveResult(cls,allchargers):
        allct = len(allchargers)
        errct = {}
        insertct = 0
        updatect = 0
        for charger in allchargers:
            if charger.m_Result=="插入":
                insertct += 1
            elif charger.m_Result=="更新":
                updatect += 1
            if charger.m_Errmsg:
                msg = charger.m_Errmsg
            else:
                msg = "处理数据"
            if msg not in errct:
                errct[msg] = 0
            errct[msg] += 1

        result = []
        result.append("输入数据:%s"%len(allchargers))
        result.append("插入数据:%s"%insertct)
        result.append("更新数据:%s" % updatect)

        for errmsg,ct in errct.items():
            result.append("%s:%s" % (errmsg,ct) )
        return result

    @classmethod
    def BlukSave(cls,allchargers):
        allct = len(allchargers)

        alldata = []

        ct = 0
        for charger in allchargers:
            #@批量插入的时候不去重
            #info = AmazonCharger.objects.filter(asin=charger.m_Asin).filter(gateway_id=charger.m_GateWay_ID).first()
            #if not info:
            info = AmazonCharger()
            charger.m_Result = "插入"
            info.gateway_id = charger.m_GateWay_ID
            info.gateway_name = charger.m_GateWay_Name
            info.asin = charger.m_Asin
            #else:
            #    charger.m_Result = "更新"
            # info = AmazonAccount()

            info.charger_id = charger.m_Charger_ID
            info.charger_name = charger.m_Charger_Name
            info.saletype = charger.m_SaleType
            info.errmsg = charger.m_Errmsg
            alldata.append(info)

            ct += 1
            if ct %1000==0:
                AmazonCharger.objects.bulk_create(alldata)
                alldata = []
                _CTime.PrintSpace("保存数据%s/%s"%(ct,allct))

        AmazonCharger.objects.bulk_create(alldata)


    def DoSave(self):
        info = AmazonCharger.objects.filter(asin=self.m_Asin).filter(gateway_name=self.m_GateWay_Name).first()
        if not info:
            info = AmazonCharger()
            self.m_Result = "插入"

            info.gateway_name  = self.m_GateWay_Name
            info.asin  = self.m_Asin
        else:
            self.m_Result = "更新"
        #info = AmazonAccount()
        info.gateway_id = self.m_GateWay_ID
        info.charger_id  = self.m_Charger_ID
        info.charger_name = self.m_Charger_Name
        info.saletype  = self.m_SaleType
        info.errmsg = self.m_Errmsg
        info.save()




    @classmethod
    def SaveReport(cls,allchargers,filename):

        with open(filename,"w") as f:
            row = 0
            allct = len(allchargers)
            for charger in allchargers:
                if row %1000==0:
                    _CTime.PrintSpace("保存报告文件%s/%s"%(row,allct))

                charger.m_InputData[4] = charger.m_Errmsg
                charger.m_InputData[5] = charger.m_Result
                data = ",".join([str(i) for i in charger.m_InputData[:5]])
                f.write(data+"\n")

                row += 1

    @classmethod
    def SaveErrData(cls,filename):
        allchargers = AmazonCharger.objects.exclude(errmsg="").all()

        with open(filename,"w") as f:
            row = 0
            allct = len(allchargers)
            f.write("Asin,网关店铺,销售,上架方式,错误信息\n")
            for charger in allchargers:
                if row %1000==0:
                    _CTime.PrintSpace("保存错误数据文件%s/%s"%(row,allct))
                data = (
                    charger.asin,
                    charger.gateway_name,
                    charger.charger_name,
                    charger.saletype,
                    charger.errmsg
                )
                #charger.m_InputData[4] =
                #charger.m_InputData[5] = charger.m_Result
                data = ",".join([str(i) for i in data])
                f.write(data+"\n")

                row += 1
# ALTER TABLE `pro_online_test`.`amazon_charger`
# ADD INDEX `forinsert` (`asin` ASC, `gateway_name` ASC);
